<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__crypto__core__cmac__v1_8c" kind="file" language="C++">
    <compoundname>cy_crypto_core_cmac_v1.c</compoundname>
    <includes local="yes" refid="cy__crypto__core__cmac__v1_8h">cy_crypto_core_cmac_v1.h</includes>
    <includes local="yes" refid="cy__crypto__core__aes__v1_8h">cy_crypto_core_aes_v1.h</includes>
    <includes local="yes" refid="cy__crypto__core__hw__v1_8h">cy_crypto_core_hw_v1.h</includes>
    <includes local="yes" refid="cy__crypto__core__mem__v1_8h">cy_crypto_core_mem_v1.h</includes>
    <includes local="yes" refid="cy__syslib_8h">cy_syslib.h</includes>
    <includes local="no">string.h</includes>
    <incdepgraph>
      <node id="84">
        <label>string.h</label>
      </node>
      <node id="83">
        <label>cy_crypto_core_cmac_v1.c</label>
        <link refid="cy__crypto__core__cmac__v1_8c" />
        <childnode refid="84" relation="include">
        </childnode>
      </node>
    </incdepgraph>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="cy__crypto__core__cmac__v1_8c_1a2870b7d31ac47c0834a7316093a538e7" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>void</type>
        <definition>static void Cy_Crypto_Core_V1_Cmac_CalcSubKey</definition>
        <argsstring>(uint8_t *srcDstPtr)</argsstring>
        <name>Cy_Crypto_Core_V1_Cmac_CalcSubKey</name>
        <param>
          <type>uint8_t *</type>
          <declname>srcDstPtr</declname>
        </param>
        <briefdescription>
<para>Calculates the sub-key for the CMAC algorithm according to the NIST publication 800-38B, page 7. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>srcDstPtr</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the source data for sub-key calculation, see 800-38B. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="78" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_cmac_v1.c" bodystart="59" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_cmac_v1.c" line="46" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cy__crypto__core__cmac__v1_8c_1aacab1a6a2c382b443ce093de2d8e9b87" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void Cy_Crypto_Core_V1_Cmac_Init</definition>
        <argsstring>(cy_stc_crypto_v1_cmac_state_t *cmacState, uint32_t *temp, uint32_t *block, uint32_t *k)</argsstring>
        <name>Cy_Crypto_Core_V1_Cmac_Init</name>
        <param>
          <type>cy_stc_crypto_v1_cmac_state_t *</type>
          <declname>cmacState</declname>
        </param>
        <param>
          <type>uint32_t *</type>
          <declname>temp</declname>
        </param>
        <param>
          <type>uint32_t *</type>
          <declname>block</declname>
        </param>
        <param>
          <type>uint32_t *</type>
          <declname>k</declname>
        </param>
        <briefdescription>
<para>The function for initialization of CMAC operation. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>cmacState</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the structure which stores the CMAC context.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>temp</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the temporary memory needed for CMAC calculation, the max needed - 128 Bytes.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>block</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the temporary storage for block, the max needed - 128 Bytes.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>k</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the sub-key. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="108" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_cmac_v1.c" bodystart="100" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_cmac_v1.c" line="100" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cy__crypto__core__cmac__v1_8c_1a44e1a551cb43c2530384bdd4c3793b0f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void Cy_Crypto_Core_V1_Cmac_Start</definition>
        <argsstring>(CRYPTO_Type *base, cy_stc_crypto_aes_state_t *aesState, cy_stc_crypto_v1_cmac_state_t *cmacState)</argsstring>
        <name>Cy_Crypto_Core_V1_Cmac_Start</name>
        <param>
          <type>CRYPTO_Type *</type>
          <declname>base</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__crypto__aes__state__t">cy_stc_crypto_aes_state_t</ref> *</type>
          <declname>aesState</declname>
        </param>
        <param>
          <type>cy_stc_crypto_v1_cmac_state_t *</type>
          <declname>cmacState</declname>
        </param>
        <briefdescription>
<para>Starts CMAC calculation. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>base</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the CRYPTO instance.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>aesState</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the structure which stores the AES context.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>cmacState</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the structure which stores the CMAC context. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="139" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_cmac_v1.c" bodystart="126" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_cmac_v1.c" line="126" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cy__crypto__core__cmac__v1_8c_1a9710fd51516658d5df9bffe93c4e21ca" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void Cy_Crypto_Core_V1_Cmac_Update</definition>
        <argsstring>(CRYPTO_Type *base, cy_stc_crypto_aes_state_t *aesState, cy_stc_crypto_v1_cmac_state_t *cmacState, uint8_t const *message, uint32_t messageSize)</argsstring>
        <name>Cy_Crypto_Core_V1_Cmac_Update</name>
        <param>
          <type>CRYPTO_Type *</type>
          <declname>base</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__crypto__aes__state__t">cy_stc_crypto_aes_state_t</ref> *</type>
          <declname>aesState</declname>
        </param>
        <param>
          <type>cy_stc_crypto_v1_cmac_state_t *</type>
          <declname>cmacState</declname>
        </param>
        <param>
          <type>uint8_t const *</type>
          <declname>message</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>messageSize</declname>
        </param>
        <briefdescription>
<para>Calculates CMAC on a message. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>base</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the CRYPTO instance.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>aesState</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the structure which stores the AES context.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>cmacState</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the structure which stores the CMAC context.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>message</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the message whose CMAC is being computed.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>messageSize</parametername>
</parameternamelist>
<parameterdescription>
<para>The size of the message whose CMAC is being computed. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="195" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_cmac_v1.c" bodystart="163" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_cmac_v1.c" line="163" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cy__crypto__core__cmac__v1_8c_1a4ef8835019ebbb3117a046912687b128" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void Cy_Crypto_Core_V1_Cmac_Finish</definition>
        <argsstring>(CRYPTO_Type *base, cy_stc_crypto_aes_state_t *aesState, cy_stc_crypto_v1_cmac_state_t *cmacState, uint8_t *cmac)</argsstring>
        <name>Cy_Crypto_Core_V1_Cmac_Finish</name>
        <param>
          <type>CRYPTO_Type *</type>
          <declname>base</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__crypto__aes__state__t">cy_stc_crypto_aes_state_t</ref> *</type>
          <declname>aesState</declname>
        </param>
        <param>
          <type>cy_stc_crypto_v1_cmac_state_t *</type>
          <declname>cmacState</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>cmac</declname>
        </param>
        <briefdescription>
<para>Completes CMAC calculation. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>base</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the CRYPTO instance.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>aesState</parametername>
</parameternamelist>
<parameterdescription>
<para>the pointer to the structure which stores the AES context.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>cmacState</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the structure which stores the CMAC context.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>cmac</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the computed CMAC value. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="247" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_cmac_v1.c" bodystart="216" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_cmac_v1.c" line="216" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cy__crypto__core__cmac__v1_8c_1ad3ab4c0f79570d176532a2187128b9e9" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref></type>
        <definition>cy_en_crypto_status_t Cy_Crypto_Core_V1_Cmac</definition>
        <argsstring>(CRYPTO_Type *base, uint8_t const *message, uint32_t messageSize, uint8_t const *key, cy_en_crypto_aes_key_length_t keyLength, uint8_t *cmac, cy_stc_crypto_aes_state_t *aesState)</argsstring>
        <name>Cy_Crypto_Core_V1_Cmac</name>
        <param>
          <type>CRYPTO_Type *</type>
          <declname>base</declname>
        </param>
        <param>
          <type>uint8_t const *</type>
          <declname>message</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>messageSize</declname>
        </param>
        <param>
          <type>uint8_t const *</type>
          <declname>key</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__crypto__enums_1ga5402841d4798c0a82d41d8433c92b62f">cy_en_crypto_aes_key_length_t</ref></type>
          <declname>keyLength</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>cmac</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__crypto__aes__state__t">cy_stc_crypto_aes_state_t</ref> *</type>
          <declname>aesState</declname>
        </param>
        <briefdescription>
<para>Performs CMAC(Cipher-based Message Authentication Code) operation on a message to produce message authentication code using AES. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>base</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the CRYPTO instance.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>message</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to a source plain text. Must be 4-byte aligned.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>messageSize</parametername>
</parameternamelist>
<parameterdescription>
<para>The size of a source plain text.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>key</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the encryption key. Must be 4-byte aligned.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>keyLength</parametername>
</parameternamelist>
<parameterdescription>
<para><ref kindref="member" refid="group__group__crypto__enums_1ga5402841d4798c0a82d41d8433c92b62f">cy_en_crypto_aes_key_length_t</ref></para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>cmac</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the calculated CMAC.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>aesState</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the AES state structure allocated by the user. The user must not modify anything in this structure.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref> </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="307" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_cmac_v1.c" bodystart="282" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_cmac_v1.c" line="282" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>This file provides the source code to the API for the CMAC method in the Crypto block driver. </para>    </briefdescription>
    <detaileddescription>
<para><simplesect kind="version"><para>2.30.3</para></simplesect>
Implementation is done in accordance with information from this weblink: nvlpubs.nist.gov/nistpubs/Legacy/SP/nistspecialpublication800-38b.pdf</para><para>Copyright 2016-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para><para>Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at</para><para><ulink url="http://www.apache.org/licenses/LICENSE-2.0">http://www.apache.org/licenses/LICENSE-2.0</ulink></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="30"><highlight class="preprocessor">#include<sp />"cy_crypto_core_cmac_v1.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="31"><highlight class="normal" /></codeline>
<codeline lineno="32"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(CY_IP_MXCRYPTO)</highlight><highlight class="normal" /></codeline>
<codeline lineno="33"><highlight class="normal" /></codeline>
<codeline lineno="34"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="35"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="36"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="37"><highlight class="normal" /></codeline>
<codeline lineno="38"><highlight class="normal" /><highlight class="preprocessor">#if<sp />(CPUSS_CRYPTO_AES<sp />==<sp />1)</highlight><highlight class="normal" /></codeline>
<codeline lineno="39"><highlight class="normal" /></codeline>
<codeline lineno="40"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_crypto_core_aes_v1.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="41"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_crypto_core_hw_v1.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="42"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_crypto_core_mem_v1.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="43"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_syslib.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="44"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;string.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="45"><highlight class="normal" /></codeline>
<codeline lineno="46"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />Cy_Crypto_Core_V1_Cmac_CalcSubKey(uint8_t<sp />*srcDstPtr);</highlight></codeline>
<codeline lineno="47"><highlight class="normal" /></codeline>
<codeline lineno="48"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="49"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_Crypto_Core_V1_Cmac_CalcSubKey</highlight></codeline>
<codeline lineno="50"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="59"><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />Cy_Crypto_Core_V1_Cmac_CalcSubKey(uint8_t<sp />*srcDstPtr)</highlight></codeline>
<codeline lineno="60"><highlight class="normal">{</highlight></codeline>
<codeline lineno="61"><highlight class="normal"><sp /><sp /><sp /><sp />int32_t<sp />i;</highlight></codeline>
<codeline lineno="62"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />c;</highlight></codeline>
<codeline lineno="63"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />msb<sp />=<sp />0UL;</highlight></codeline>
<codeline lineno="64"><highlight class="normal" /></codeline>
<codeline lineno="65"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(i<sp />=<sp />(int32_t)((int32_t)<ref kindref="member" refid="group__group__crypto__cli__srv__macros_1gab966285a569cc381f21ca7ebb9918128">CY_CRYPTO_AES_BLOCK_SIZE</ref><sp />-<sp />1);<sp />i<sp />&gt;=<sp />0;<sp />i--)</highlight></codeline>
<codeline lineno="66"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="67"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />c<sp />=<sp />(uint32_t)srcDstPtr[i];</highlight></codeline>
<codeline lineno="68"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />c<sp />=<sp />(c<sp />&lt;&lt;<sp />1U)<sp />|<sp />msb;</highlight></codeline>
<codeline lineno="69"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />srcDstPtr[i]<sp />=<sp />(uint8_t)<sp />c;</highlight></codeline>
<codeline lineno="70"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />msb<sp />=<sp />(c<sp />&gt;&gt;<sp />8U)<sp />&amp;<sp />1UL;</highlight></codeline>
<codeline lineno="71"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="72"><highlight class="normal" /></codeline>
<codeline lineno="73"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0UL<sp />!=<sp />msb)</highlight></codeline>
<codeline lineno="74"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="75"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Just<sp />one<sp />byte<sp />is<sp />valuable,<sp />the<sp />rest<sp />are<sp />zeros<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="76"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />srcDstPtr[(uint8_t)(<ref kindref="member" refid="group__group__crypto__cli__srv__macros_1gab966285a569cc381f21ca7ebb9918128">CY_CRYPTO_AES_BLOCK_SIZE</ref><sp />-<sp />1U)]<sp />^=<sp />CY_CRYPTO_CMAC_RB;</highlight></codeline>
<codeline lineno="77"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="78"><highlight class="normal">}</highlight></codeline>
<codeline lineno="79"><highlight class="normal" /></codeline>
<codeline lineno="80"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="81"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_Crypto_Core_V1_Cmac_Init</highlight></codeline>
<codeline lineno="82"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="100"><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />Cy_Crypto_Core_V1_Cmac_Init(cy_stc_crypto_v1_cmac_state_t*<sp />cmacState,</highlight></codeline>
<codeline lineno="101"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t*<sp />temp,</highlight></codeline>
<codeline lineno="102"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t*<sp />block,</highlight></codeline>
<codeline lineno="103"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t*<sp />k)</highlight></codeline>
<codeline lineno="104"><highlight class="normal">{</highlight></codeline>
<codeline lineno="105"><highlight class="normal"><sp /><sp /><sp /><sp />cmacState-&gt;block<sp />=<sp />block;</highlight></codeline>
<codeline lineno="106"><highlight class="normal"><sp /><sp /><sp /><sp />cmacState-&gt;temp<sp /><sp />=<sp />temp;</highlight></codeline>
<codeline lineno="107"><highlight class="normal"><sp /><sp /><sp /><sp />cmacState-&gt;k<sp /><sp /><sp /><sp /><sp />=<sp />k;</highlight></codeline>
<codeline lineno="108"><highlight class="normal">}</highlight></codeline>
<codeline lineno="109"><highlight class="normal" /></codeline>
<codeline lineno="110"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="111"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_Crypto_Core_V1_Cmac_Start</highlight></codeline>
<codeline lineno="112"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="126"><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />Cy_Crypto_Core_V1_Cmac_Start(CRYPTO_Type<sp />*base,</highlight></codeline>
<codeline lineno="127"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__crypto__aes__state__t">cy_stc_crypto_aes_state_t</ref><sp /><sp />*aesState,</highlight></codeline>
<codeline lineno="128"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_stc_crypto_v1_cmac_state_t<sp />*cmacState)</highlight></codeline>
<codeline lineno="129"><highlight class="normal">{</highlight></codeline>
<codeline lineno="130"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />*kTmp<sp /><sp /><sp /><sp />=<sp />cmacState-&gt;k;</highlight></codeline>
<codeline lineno="131"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />*tempTmp<sp />=<sp />cmacState-&gt;temp;</highlight></codeline>
<codeline lineno="132"><highlight class="normal" /></codeline>
<codeline lineno="133"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Calculate<sp />the<sp />K1<sp />sub-key<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="134"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_MemSet(base,<sp />(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*)tempTmp,<sp />0U,<sp /><ref kindref="member" refid="group__group__crypto__cli__srv__macros_1gab966285a569cc381f21ca7ebb9918128">CY_CRYPTO_AES_BLOCK_SIZE</ref>);</highlight></codeline>
<codeline lineno="135"><highlight class="normal" /></codeline>
<codeline lineno="136"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_Aes_ProcessBlock(base,<sp />aesState,<sp /><ref kindref="member" refid="group__group__crypto__enums_1ggae040fb530d4d110976bedfcdb7c8f09ca4b95ef1e3f73771b0c6a376c6d43e16d">CY_CRYPTO_ENCRYPT</ref>,<sp />kTmp,<sp />tempTmp);</highlight></codeline>
<codeline lineno="137"><highlight class="normal" /></codeline>
<codeline lineno="138"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_Cmac_CalcSubKey((uint8_t*)kTmp);</highlight></codeline>
<codeline lineno="139"><highlight class="normal">}</highlight></codeline>
<codeline lineno="140"><highlight class="normal" /></codeline>
<codeline lineno="141"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="142"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_Crypto_Core_V1_Cmac_Update</highlight></codeline>
<codeline lineno="143"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="163"><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />Cy_Crypto_Core_V1_Cmac_Update(CRYPTO_Type<sp />*base,</highlight></codeline>
<codeline lineno="164"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__crypto__aes__state__t">cy_stc_crypto_aes_state_t</ref><sp /><sp />*aesState,</highlight></codeline>
<codeline lineno="165"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_stc_crypto_v1_cmac_state_t<sp />*cmacState,</highlight></codeline>
<codeline lineno="166"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*message,</highlight></codeline>
<codeline lineno="167"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />messageSize)</highlight></codeline>
<codeline lineno="168"><highlight class="normal">{</highlight></codeline>
<codeline lineno="169"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />*blockBuff<sp />=<sp />cmacState-&gt;block;</highlight></codeline>
<codeline lineno="170"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />*tempBuff<sp /><sp />=<sp />cmacState-&gt;temp;</highlight></codeline>
<codeline lineno="171"><highlight class="normal" /></codeline>
<codeline lineno="172"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Clear<sp />the<sp />argument<sp />for<sp />XOR<sp />for<sp />the<sp />first<sp />block<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="173"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_MemSet(base,<sp />(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*<sp />)tempBuff,<sp />0x00U,<sp /><ref kindref="member" refid="group__group__crypto__cli__srv__macros_1gab966285a569cc381f21ca7ebb9918128">CY_CRYPTO_AES_BLOCK_SIZE</ref>);</highlight></codeline>
<codeline lineno="174"><highlight class="normal" /></codeline>
<codeline lineno="175"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Process<sp />all<sp />blocks<sp />except<sp />last<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="176"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(messageSize<sp />&gt;<sp /><ref kindref="member" refid="group__group__crypto__cli__srv__macros_1gab966285a569cc381f21ca7ebb9918128">CY_CRYPTO_AES_BLOCK_SIZE</ref>)</highlight></codeline>
<codeline lineno="177"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="178"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Copy<sp />the<sp />source<sp />message<sp />block<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="179"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_MemCpy(base,<sp />blockBuff,<sp />message,<sp /><ref kindref="member" refid="group__group__crypto__cli__srv__macros_1gab966285a569cc381f21ca7ebb9918128">CY_CRYPTO_AES_BLOCK_SIZE</ref>);</highlight></codeline>
<codeline lineno="180"><highlight class="normal" /></codeline>
<codeline lineno="181"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_Aes_Xor(base,<sp />aesState,<sp />blockBuff,<sp />blockBuff,<sp />tempBuff);</highlight></codeline>
<codeline lineno="182"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_Aes_ProcessBlock(base,</highlight></codeline>
<codeline lineno="183"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />aesState,<sp /><ref kindref="member" refid="group__group__crypto__enums_1ggae040fb530d4d110976bedfcdb7c8f09ca4b95ef1e3f73771b0c6a376c6d43e16d">CY_CRYPTO_ENCRYPT</ref>,<sp />tempBuff,<sp />blockBuff);</highlight></codeline>
<codeline lineno="184"><highlight class="normal" /></codeline>
<codeline lineno="185"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />in<sp />bytes<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="186"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />message<sp /><sp /><sp /><sp /><sp />+=<sp /><ref kindref="member" refid="group__group__crypto__cli__srv__macros_1gab966285a569cc381f21ca7ebb9918128">CY_CRYPTO_AES_BLOCK_SIZE</ref>;</highlight></codeline>
<codeline lineno="187"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />messageSize<sp />-=<sp /><ref kindref="member" refid="group__group__crypto__cli__srv__macros_1gab966285a569cc381f21ca7ebb9918128">CY_CRYPTO_AES_BLOCK_SIZE</ref>;</highlight></codeline>
<codeline lineno="188"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="189"><highlight class="normal" /></codeline>
<codeline lineno="190"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />calculation<sp />size<sp />of<sp />the<sp />last<sp />block<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="191"><highlight class="normal"><sp /><sp /><sp /><sp />aesState-&gt;blockIdx<sp />=<sp />messageSize;</highlight></codeline>
<codeline lineno="192"><highlight class="normal" /></codeline>
<codeline lineno="193"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Copy<sp />the<sp />last<sp />block<sp />to<sp />the<sp />block<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="194"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_MemCpy(base,<sp />(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*)blockBuff,<sp />(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*)message,<sp />(uint16_t)aesState-&gt;blockIdx);</highlight></codeline>
<codeline lineno="195"><highlight class="normal">}</highlight></codeline>
<codeline lineno="196"><highlight class="normal" /></codeline>
<codeline lineno="197"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="198"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_Crypto_Core_V1_Cmac_Finish</highlight></codeline>
<codeline lineno="199"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="216"><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />Cy_Crypto_Core_V1_Cmac_Finish(CRYPTO_Type<sp />*base,</highlight></codeline>
<codeline lineno="217"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__crypto__aes__state__t">cy_stc_crypto_aes_state_t</ref><sp /><sp />*aesState,</highlight></codeline>
<codeline lineno="218"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_stc_crypto_v1_cmac_state_t<sp />*cmacState,</highlight></codeline>
<codeline lineno="219"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t*<sp />cmac)</highlight></codeline>
<codeline lineno="220"><highlight class="normal">{</highlight></codeline>
<codeline lineno="221"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />*blockBuff<sp /><sp /><sp />=<sp />cmacState-&gt;block;</highlight></codeline>
<codeline lineno="222"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />*tempBuff<sp /><sp /><sp /><sp />=<sp />cmacState-&gt;temp;</highlight></codeline>
<codeline lineno="223"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />*kPtrTmp<sp /><sp /><sp /><sp /><sp />=<sp />cmacState-&gt;k;</highlight></codeline>
<codeline lineno="224"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp /><sp />blockIdxTmp<sp />=<sp />aesState-&gt;blockIdx;</highlight></codeline>
<codeline lineno="225"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp /><sp />copySize;</highlight></codeline>
<codeline lineno="226"><highlight class="normal" /></codeline>
<codeline lineno="227"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(blockIdxTmp<sp />&lt;<sp /><ref kindref="member" refid="group__group__crypto__cli__srv__macros_1gab966285a569cc381f21ca7ebb9918128">CY_CRYPTO_AES_BLOCK_SIZE</ref>)</highlight></codeline>
<codeline lineno="228"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="229"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Calculate<sp />the<sp />K2<sp />sub-key<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="230"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_Cmac_CalcSubKey((uint8_t*<sp />)kPtrTmp);</highlight></codeline>
<codeline lineno="231"><highlight class="normal" /></codeline>
<codeline lineno="232"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Appended<sp />'1'<sp />bit<sp />to<sp />the<sp />end<sp />of<sp />message,<sp />followed<sp />by<sp />'0'<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="233"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*((uint8_t*<sp />)blockBuff<sp />+<sp />blockIdxTmp)<sp />=<sp />0x80U;</highlight></codeline>
<codeline lineno="234"><highlight class="normal" /></codeline>
<codeline lineno="235"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Write<sp />zeros<sp />into<sp />the<sp />rest<sp />of<sp />the<sp />message<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="236"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />copySize<sp />=<sp /><ref kindref="member" refid="group__group__crypto__cli__srv__macros_1gab966285a569cc381f21ca7ebb9918128">CY_CRYPTO_AES_BLOCK_SIZE</ref><sp />-<sp />1u<sp />-<sp />blockIdxTmp;</highlight></codeline>
<codeline lineno="237"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_MemSet(base,<sp />((uint8_t*<sp />)blockBuff<sp />+<sp />blockIdxTmp<sp />+<sp />1),<sp />0x00U,<sp />(uint16_t)copySize);</highlight></codeline>
<codeline lineno="238"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="239"><highlight class="normal" /></codeline>
<codeline lineno="240"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_Aes_Xor(base,<sp />aesState,<sp />blockBuff,<sp />blockBuff,<sp />tempBuff);</highlight></codeline>
<codeline lineno="241"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_Aes_Xor(base,<sp />aesState,<sp />blockBuff,<sp />blockBuff,<sp />kPtrTmp);</highlight></codeline>
<codeline lineno="242"><highlight class="normal" /></codeline>
<codeline lineno="243"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_Aes_ProcessBlock(base,<sp />aesState,<sp /><ref kindref="member" refid="group__group__crypto__enums_1ggae040fb530d4d110976bedfcdb7c8f09ca4b95ef1e3f73771b0c6a376c6d43e16d">CY_CRYPTO_ENCRYPT</ref>,<sp />tempBuff,<sp />blockBuff);</highlight></codeline>
<codeline lineno="244"><highlight class="normal" /></codeline>
<codeline lineno="245"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Copy<sp />the<sp />result<sp />to<sp />the<sp />cmac<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="246"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_MemCpy(base,<sp />cmac,<sp />tempBuff,<sp /><ref kindref="member" refid="group__group__crypto__cli__srv__macros_1gab966285a569cc381f21ca7ebb9918128">CY_CRYPTO_AES_BLOCK_SIZE</ref>);</highlight></codeline>
<codeline lineno="247"><highlight class="normal">}</highlight></codeline>
<codeline lineno="248"><highlight class="normal" /></codeline>
<codeline lineno="249"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="250"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_Crypto_Core_V1_Cmac</highlight></codeline>
<codeline lineno="251"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="282"><highlight class="normal"><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref><sp />Cy_Crypto_Core_V1_Cmac(CRYPTO_Type<sp />*base,</highlight></codeline>
<codeline lineno="283"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*message,</highlight></codeline>
<codeline lineno="284"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />messageSize,</highlight></codeline>
<codeline lineno="285"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />*key,</highlight></codeline>
<codeline lineno="286"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__enums_1ga5402841d4798c0a82d41d8433c92b62f">cy_en_crypto_aes_key_length_t</ref><sp />keyLength,</highlight></codeline>
<codeline lineno="287"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp />*cmac,</highlight></codeline>
<codeline lineno="288"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__crypto__aes__state__t">cy_stc_crypto_aes_state_t</ref><sp />*aesState)</highlight></codeline>
<codeline lineno="289"><highlight class="normal">{</highlight></codeline>
<codeline lineno="290"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__crypto__aes__buffers__t">cy_stc_crypto_aes_buffers_t</ref><sp /><sp />*aesBuffers<sp />=<sp />(<ref kindref="compound" refid="structcy__stc__crypto__aes__buffers__t">cy_stc_crypto_aes_buffers_t</ref><sp />*)(<ref kindref="member" refid="group__group__crypto__lld__hw__functions_1ga07acf748f85c91a73ad9b8d78a2f70a5">Cy_Crypto_Core_GetVuMemoryAddress</ref>(base));</highlight></codeline>
<codeline lineno="291"><highlight class="normal"><sp /><sp /><sp /><sp />cy_stc_crypto_cmac_buffers_t<sp />*cmacBuffers<sp />=</highlight></codeline>
<codeline lineno="292"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(cy_stc_crypto_cmac_buffers_t<sp />*)((uint8_t*)aesBuffers<sp />+<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(<ref kindref="compound" refid="structcy__stc__crypto__aes__buffers__t">cy_stc_crypto_aes_buffers_t</ref>));</highlight></codeline>
<codeline lineno="293"><highlight class="normal" /></codeline>
<codeline lineno="294"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />*myBlock<sp />=<sp />(uint32_t*)(&amp;cmacBuffers-&gt;block0);</highlight></codeline>
<codeline lineno="295"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />*myTemp<sp /><sp />=<sp />(uint32_t*)(&amp;cmacBuffers-&gt;block1);</highlight></codeline>
<codeline lineno="296"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />*myK<sp /><sp /><sp /><sp /><sp />=<sp />(uint32_t*)(&amp;cmacBuffers-&gt;k);</highlight></codeline>
<codeline lineno="297"><highlight class="normal"><sp /><sp /><sp /><sp />cy_stc_crypto_v1_cmac_state_t<sp />*myCmacState<sp />=<sp />&amp;cmacBuffers-&gt;cmacState;</highlight></codeline>
<codeline lineno="298"><highlight class="normal" /></codeline>
<codeline lineno="299"><highlight class="normal"><sp /><sp /><sp /><sp />(void)Cy_Crypto_Core_V1_Aes_Init(base,<sp />key,<sp />keyLength,<sp />aesState,<sp />aesBuffers);</highlight></codeline>
<codeline lineno="300"><highlight class="normal" /></codeline>
<codeline lineno="301"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_Cmac_Init<sp /><sp />(myCmacState,<sp />myTemp,<sp />myBlock,<sp />myK);</highlight></codeline>
<codeline lineno="302"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_Cmac_Start<sp />(base,<sp />aesState,<sp />myCmacState);</highlight></codeline>
<codeline lineno="303"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_Cmac_Update(base,<sp />aesState,<sp />myCmacState,<sp />message,<sp />messageSize);</highlight></codeline>
<codeline lineno="304"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Core_V1_Cmac_Finish(base,<sp />aesState,<sp />myCmacState,<sp />cmac);</highlight></codeline>
<codeline lineno="305"><highlight class="normal" /></codeline>
<codeline lineno="306"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada15d5a5e1314e16c159b7d3fd6f3501b8">CY_CRYPTO_SUCCESS</ref>);</highlight></codeline>
<codeline lineno="307"><highlight class="normal">}</highlight></codeline>
<codeline lineno="308"><highlight class="normal" /></codeline>
<codeline lineno="309"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />(CPUSS_CRYPTO_AES<sp />==<sp />1)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="310"><highlight class="normal" /></codeline>
<codeline lineno="311"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="312"><highlight class="normal">}</highlight></codeline>
<codeline lineno="313"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="314"><highlight class="normal" /></codeline>
<codeline lineno="315"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXCRYPTO<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="316"><highlight class="normal" /></codeline>
<codeline lineno="317"><highlight class="normal" /></codeline>
<codeline lineno="318"><highlight class="normal" /><highlight class="comment">/*<sp />[]<sp />END<sp />OF<sp />FILE<sp />*/</highlight><highlight class="normal" /></codeline>
    </programlisting>
    <location file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_cmac_v1.c" />
  </compounddef>
</doxygen>